<?php

declare(strict_types=1);

namespace Dedi\SyliusSettingsPlugin\Model;

class Config
{
    public function __construct(
        private readonly string $name,
        private readonly string $model,
        private readonly string $factory,
        private readonly string $provider,
        private readonly ?string $permission,
        private readonly array $keys,
    ) {
    }

    public function getName(): string
    {
        return $this->name;
    }

    public function getModel(): string
    {
        return $this->model;
    }

    public function getFactory(): string
    {
        return $this->factory;
    }

    public function getProvider(): string
    {
        return $this->provider;
    }

    public function getKeys(): array
    {
        return $this->keys;
    }

    public function getPermission(): ?string
    {
        return $this->permission;
    }
}
