<?php

declare(strict_types=1);

namespace Dedi\SyliusSettingsPlugin\Security\Authorization;

use Sylius\Bundle\ResourceBundle\Controller\AuthorizationCheckerInterface;
use Sylius\Bundle\ResourceBundle\Controller\RequestConfiguration;

class CompositeAuthorizationChecker implements AuthorizationCheckerInterface
{
    public function __construct(private readonly CheckerRegistry $checkerRegistry)
    {
    }

    public function isGranted(RequestConfiguration $configuration, string $permission): bool
    {
        $domain = explode('.', $permission);

        $checker = $this->checkerRegistry->getChecker($domain[0]);

        if (null === $checker) {
            return true;
        }

        return $checker->isGranted();
    }
}
